# -*- cperl -*-

# test if the optimization code works correctly

#use strict;
use Test;

BEGIN { $| = 1; plan tests => 12 }

use SUGR;
use PDL;

my $v3 = vsequence(3);
my $v4 = vsequence(4);
my $v6 = vsequence(6);

my $Pi     = SUGR::Basic::Pi($v4);
my $Pi_bak = SUGR::Basic::Pi_bak($v4);
ok(ref($Pi),'PDL::Matrix');
ok(sum($Pi==$Pi_bak),24);

my $Pidual     = SUGR::Basic::Pidual($v4);
my $Pidual_bak = SUGR::Basic::Pidual_bak($v4);
ok(ref($Pidual),'PDL::Matrix');
ok(sum($Pidual==$Pidual_bak),24);


my $Gamma     = SUGR::Basic::Gamma($v6);
my $Gamma_bak = SUGR::Basic::Gamma_bak($v6);
ok(ref($Gamma),'PDL::Matrix');
ok(sum($Gamma==$Gamma_bak),16);

my $Gammadual     = SUGR::Basic::Gammadual($v6);
my $Gammadual_bak = SUGR::Basic::Gammadual_bak($v6);
ok(ref($Gammadual),'PDL::Matrix');
ok(sum($Gammadual==$Gammadual_bak),16);

my $S     = SUGR::Basic::S($v3);
my $S_bak = SUGR::Basic::S_bak($v3);
ok(ref($S),'PDL::Matrix');
ok(sum($S==$S_bak),9);

use SUGR::Optimize qw/adjoint_3x3/;

my $M = msequence(3,3);
my $Amaple = mpdl([[-3, 6, -3], [6, -12, 6], [-3, 6, -3]]);
my $A = mzeroes(3,3);
$M->adjoint_3x3($A);
ok(ref($A),'PDL::Matrix');
ok(sum($Amaple==$A),9);
